package cn.iocoder.yudao.module.mes.service.producereport;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.mes.controller.admin.producereport.vo.ProduceReportDetailPageReqVO;
import cn.iocoder.yudao.module.mes.controller.admin.producereport.vo.ProduceReportDetailRespVO;
import cn.iocoder.yudao.module.mes.controller.admin.producereport.vo.ProduceReportDetailSaveReqVO;
import cn.iocoder.yudao.module.mes.dal.dataobject.producereport.ProduceReportDetailDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 生产报工明细 Service 接口
 *
 * @author 内蒙必硕
 */
public interface ProduceReportDetailService {

    /**
     * 创建生产报工明细
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createProduceReportDetail(@Valid ProduceReportDetailSaveReqVO createReqVO);

    /**
     * 更新生产报工明细
     *
     * @param updateReqVO 更新信息
     */
    void updateProduceReportDetail(@Valid ProduceReportDetailSaveReqVO updateReqVO);

    /**
     * 删除生产报工明细
     *
     * @param id 编号
     */
    void deleteProduceReportDetail(Long id);

    /**
     * 获得生产报工明细
     *
     * @param id 编号
     * @return 生产报工明细
     */
    ProduceReportDetailDO getProduceReportDetail(Long id);

    /**
     * 获得生产报工明细分页
     *
     * @param pageReqVO 分页查询
     * @return 生产报工明细分页
     */
    PageResult<ProduceReportDetailRespVO> getProduceReportDetailPage(ProduceReportDetailPageReqVO pageReqVO);
    /**
     * 获得生产报工明细分页
     * 查询个人所属，或是代报工的页面数据
     * @param pageReqVO 分页查询
     * @return 生产报工明细分页
     */
    PageResult<ProduceReportDetailRespVO> getCenterPage(ProduceReportDetailPageReqVO pageReqVO);
    List<ProduceReportDetailRespVO> buildVOList(List<ProduceReportDetailDO> list);

    void updateStatus(Long id, Integer status);
    void updateStatus2( ProduceReportDetailDO reportDetailDO, Integer status);

    Long sumByPlanAndOrgType(Long planId,String orgType);

    //报工明细分配固定单个计划
   void updateStatus3( ProduceReportDetailDO reportDetailDO, Integer status);
}